Index: palm/trunk/SOURCE/land_surface_model.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model.f90	(revision 1686)
+++ palm/trunk/SOURCE/land_surface_model.f90	(revision 1691)
@@ -1301,4 +1368,21 @@
        ENDDO
 
+#if defined( __parallel )
+!
+!--    Make a logical OR for all processes. Force radiation call if at
+!--    least one processor
+       IF ( intermediate_timestep_count == intermediate_timestep_count_max-1 )&
+       THEN
+
+          IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+          CALL MPI_ALLREDUCE( force_radiation_call_l, force_radiation_call,    &
+                              1, MPI_LOGICAL, MPI_LOR, comm2d, ierr )
+#else
+          force_radiation_call = force_radiation_call_l
+#endif
+          force_radiation_call_l = .FALSE.
+       ENDIF
+
+
     END SUBROUTINE lsm_energy_balance
 
@@ -1322,10 +1406,10 @@
 
        REAL(wp), DIMENSION(nzb_soil:nzt_soil) :: gamma_temp,  & !< temp. gamma
-                                               lambda_temp, & !< temp. lambda
-                                               tend           !< tendency
-
-       DO i = nxlg, nxrg    
-          DO j = nysg, nyng
-             DO k = nzb_soil, nzt_soil
+                                                 lambda_temp, & !< temp. lambda
+                                                 tend           !< tendency
+
+       DO  i = nxlg, nxrg
+          DO  j = nysg, nyng
+             DO  k = nzb_soil, nzt_soil
 !
 !--             Calculate volumetric heat capacity of the soil, taking into 
@@ -1335,8 +1419,12 @@
 
 !
-!--             Calculate soil heat conductivity at the center of the soil 
+!--             Calculate soil heat conductivity at the center of the soil
 !--             layers
+                lambda_h_sat = lambda_h_sm ** (1.0_wp - m_sat(j,i)) *          &
+                               lambda_h_water ** m_soil(k,j,i)
+
                 ke = 1.0_wp + LOG10(MAX(0.1_wp,m_soil(k,j,i) / m_sat(j,i)))
-                lambda_temp(k) = ke * (lambda_h_sat(j,i) + lambda_h_dry) +     &
+
+                lambda_temp(k) = ke * (lambda_h_sat - lambda_h_dry) +          &
                                  lambda_h_dry
 
@@ -1346,10 +1434,6 @@
 !--          Calculate soil heat conductivity (lambda_h) at the _stag level 
 !--          using linear interpolation
-             DO k = nzb_soil, nzt_soil-1
-                  
-                lambda_h(k,j,i) = lambda_temp(k) +                             &
-                                  ( lambda_temp(k+1) - lambda_temp(k) )        &
-                                  * 0.5 * dz_soil_stag(k) * ddz_soil(k+1)
-
+             DO  k = nzb_soil, nzt_soil-1
+                lambda_h(k,j,i) = ( lambda_temp(k+1) + lambda_temp(k) ) * 0.5_wp
              ENDDO
              lambda_h(nzt_soil,j,i) = lambda_temp(nzt_soil)
@@ -1358,17 +1442,20 @@
 !--          Prognostic equation for soil temperature t_soil
              tend(:) = 0.0_wp
-             tend(0) = (1.0_wp/rho_c_total(nzb_soil,j,i)) *                    &
+             tend(nzb_soil) = (1.0_wp/rho_c_total(nzb_soil,j,i)) *             &
                        ( lambda_h(nzb_soil,j,i) * ( t_soil(nzb_soil+1,j,i)     &
-                         - t_soil(nzb_soil,j,i) ) * ddz_soil(nzb_soil)         &
+                         - t_soil(nzb_soil,j,i) ) * ddz_soil(nzb_soil+1)       &
                          + ghf_eb(j,i) ) * ddz_soil_stag(nzb_soil)
 
-             DO  k = 1, nzt_soil
+
+
+
+             DO  k = nzb_soil+1, nzt_soil
                 tend(k) = (1.0_wp/rho_c_total(k,j,i))                          &
                           * (   lambda_h(k,j,i)                                &
                               * ( t_soil(k+1,j,i) - t_soil(k,j,i) )            &
-                              * ddz_soil(k)                                    &
+                              * ddz_soil(k+1)                                  &
                               - lambda_h(k-1,j,i)                              &
                               * ( t_soil(k,j,i) - t_soil(k-1,j,i) )            &
-                              * ddz_soil(k-1)                                  &
+                              * ddz_soil(k)                                    &
                             ) * ddz_soil_stag(k)
              ENDDO
@@ -1396,5 +1483,5 @@
 
 
-             DO k = nzb_soil, nzt_soil
+             DO  k = nzb_soil, nzt_soil
 
 !
@@ -1414,4 +1501,5 @@
                               / (n_vg(j,i)-1.0_wp)) - 1.0_wp                   &
                           )**(1.0_wp/n_vg(j,i)) / alpha_vg(j,i)
+
 
                    gamma_temp(k) = gamma_w_sat(j,i) * ( ( (1.0_wp +            &
@@ -1438,12 +1526,10 @@
 !--             using linear interpolation. To do: replace this with
 !--             ECMWF-IFS Eq. 8.81
-                DO k = nzb_soil, nzt_soil-1
+                DO  k = nzb_soil, nzt_soil-1
                      
-                   lambda_w(k,j,i) = lambda_temp(k) +                          &
-                                     ( lambda_temp(k+1) - lambda_temp(k) )     &
-                                     * 0.5_wp * dz_soil_stag(k) * ddz_soil(k+1)
-                   gamma_w(k,j,i)  = gamma_temp(k) +                           &
-                                     ( gamma_temp(k+1) - gamma_temp(k) )       &
-                                     * 0.5_wp * dz_soil_stag(k) * ddz_soil(k+1)                 
+                   lambda_w(k,j,i) = ( lambda_temp(k+1) + lambda_temp(k) )     &
+                                     * 0.5_wp
+                   gamma_w(k,j,i)  = ( gamma_temp(k+1) + gamma_temp(k) )       &
+                                     * 0.5_wp
 
                 ENDDO
@@ -1457,5 +1543,5 @@
                    gamma_w(nzt_soil,j,i) = 0.0_wp
                 ELSE
-                   gamma_w(nzt_soil,j,i) = lambda_temp(nzt_soil)
+                   gamma_w(nzt_soil,j,i) = gamma_temp(nzt_soil)
                 ENDIF     
 
@@ -1470,23 +1556,22 @@
 
 !
-!--             Calculate the root extraction (ECMWF 7.69, modified so that the
-!--             sum of root_extr = 1). The energy balance solver guarantees a 
-!--             positive transpiration, so that there is no need for an 
-!--             additional check.
-
-                m_total = 0.0_wp
-                DO k = nzb_soil, nzt_soil
-                    IF ( m_soil(k,j,i) .GT. m_wilt(j,i) )  THEN
+!--             Calculate the root extraction (ECMWF 7.69, the sum of root_extr
+!--             = 1). The energy balance solver guarantees a positive
+!--             transpiration, so that there is no need for an additional check.
+                DO  k = nzb_soil, nzt_soil
+                    IF ( m_soil(k,j,i) > m_wilt(j,i) )  THEN
                        m_total = m_total + root_fr(k,j,i) * m_soil(k,j,i)
                     ENDIF
                 ENDDO  
 
-                DO k = nzb_soil, nzt_soil 
-                   IF ( m_soil(k,j,i) .GT. m_wilt(j,i) )  THEN
-                      root_extr(k) = root_fr(k,j,i) * m_soil(k,j,i) / m_total
-                   ELSE
-                      root_extr(k) = 0.0_wp
-                   ENDIF
-                ENDDO
+                IF ( m_total > 0.0_wp )  THEN
+                   DO  k = nzb_soil, nzt_soil
+                      IF ( m_soil(k,j,i) > m_wilt(j,i) )  THEN
+                         root_extr(k) = root_fr(k,j,i) * m_soil(k,j,i) / m_total
+                      ELSE
+                         root_extr(k) = 0.0_wp
+                      ENDIF
+                   ENDDO
+                ENDIF
 
 !
@@ -1495,5 +1580,5 @@
                 tend(nzb_soil) = ( lambda_w(nzb_soil,j,i) * (                  &
                             m_soil(nzb_soil+1,j,i) - m_soil(nzb_soil,j,i) )    &
-                            * ddz_soil(nzb_soil) - gamma_w(nzb_soil,j,i) - (   &
+                            * ddz_soil(nzb_soil+1) - gamma_w(nzb_soil,j,i) - ( &
                             root_extr(nzb_soil) * qsws_veg_eb(j,i)             &
                             + qsws_soil_eb(j,i) ) * drho_l_lv )                &
@@ -1502,9 +1587,9 @@
                 DO  k = nzb_soil+1, nzt_soil-1
                    tend(k) = ( lambda_w(k,j,i) * ( m_soil(k+1,j,i)             &
-                               - m_soil(k,j,i) ) * ddz_soil(k) - gamma_w(k,j,i)&
-                               - lambda_w(k-1,j,i) * (m_soil(k,j,i) -          &
-                               m_soil(k-1,j,i)) * ddz_soil(k-1)                &
-                               + gamma_w(k-1,j,i) - (root_extr(k)              &
-                               * qsws_veg_eb(j,i) * drho_l_lv)                 &
+                             - m_soil(k,j,i) ) * ddz_soil(k+1) - gamma_w(k,j,i)&
+                             - lambda_w(k-1,j,i) * (m_soil(k,j,i) -            &
+                             m_soil(k-1,j,i)) * ddz_soil(k)                    &
+                             + gamma_w(k-1,j,i) - (root_extr(k)                &
+                             * qsws_veg_eb(j,i) * drho_l_lv)                   &
                              ) * ddz_soil_stag(k)
 
@@ -1514,5 +1599,5 @@
                                         * (m_soil(nzt_soil,j,i)                &
                                         - m_soil(nzt_soil-1,j,i))              &
-                                        * ddz_soil(nzt_soil-1)                 &
+                                        * ddz_soil(nzt_soil)                   &
                                         + gamma_w(nzt_soil-1,j,i) - (          &
                                           root_extr(nzt_soil)                  &
@@ -1573,13 +1658,12 @@
        REAL(wp) :: resistance    !< aerodynamic and soil resistance term
 
-       DO i = nxlg, nxrg    
-          DO j = nysg, nyng
+       DO  i = nxlg, nxrg    
+          DO  j = nysg, nyng
              k = nzb_s_inner(j,i)
 
 !
 !--          Calculate water vapour pressure at saturation
-             e_s = 0.01_wp * 610.78_wp * EXP( 17.269_wp * ( t_surface(j,i)     &
-                                              - 273.16_wp ) / ( t_surface(j,i) &
-                                              - 35.86_wp ) )
+             e_s = 0.01_wp * 610.78_wp * EXP( 17.269_wp * ( t_surface_p(j,i)   &
+                   - 273.16_wp ) / ( t_surface_p(j,i) - 35.86_wp ) )
 
 !
@@ -1587,11 +1671,19 @@
              q_s = 0.622_wp * e_s / surface_pressure
 
-
              resistance = r_a(j,i) / (r_a(j,i) + r_s(j,i))
 
 !
 !--          Calculate specific humidity at surface
-             q_p(k,j,i) = resistance * q_s + (1.0_wp - resistance)             &
-                          * q_p(k+1,j,i)
+             IF ( cloud_physics )  THEN
+                q(k,j,i) = resistance * q_s + (1.0_wp - resistance)            &
+                             * ( q(k+1,j,i) - ql(k+1,j,i) )
+             ELSE
+                q(k,j,i) = resistance * q_s + (1.0_wp - resistance)            &
+                             * q(k+1,j,i)
+             ENDIF
+
+!
+!--          Update virtual potential temperature
+             vpt(k,j,i) = pt(k,j,i) * ( 1.0_wp + 0.61_wp * q(k,j,i) )
 
           ENDDO
Index: palm/trunk/SOURCE/lpm_advec.f90
===================================================================
--- palm/trunk/SOURCE/lpm_advec.f90	(revision 1686)
+++ palm/trunk/SOURCE/lpm_advec.f90	(revision 1691)
@@ -14,10 +14,10 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! ------------------
-!
+! Renamed prandtl_layer to constant_flux_layer.
 !
 ! Former revisions:
@@ -83,6 +83,6 @@
 
     USE control_parameters,                                                    &
-        ONLY:  atmos_ocean_sign, cloud_droplets, dt_3d, dt_3d_reached_l, dz,   &
-               g, kappa, molecular_viscosity, prandtl_layer, topography,       &
+        ONLY:  atmos_ocean_sign, cloud_droplets, constant_flux_layer, dt_3d,   &
+               dt_3d_reached_l, dz, g, kappa, molecular_viscosity, topography, &
                u_gtrans, v_gtrans, simulated_time
 
@@ -224,5 +224,5 @@
 !--       First, check if particle is located below first vertical grid level 
 !--       (Prandtl-layer height)
-          IF ( prandtl_layer  .AND.  particles(n)%z < z_p )  THEN
+          IF ( constant_flux_layer  .AND.  particles(n)%z < z_p )  THEN
 !
 !--          Resolved-scale horizontal particle velocity is zero below z0. 
@@ -294,5 +294,5 @@
        DO  n = start_index(nb), end_index(nb)
 
-          IF ( prandtl_layer  .AND.  particles(n)%z < z_p )  THEN
+          IF ( constant_flux_layer  .AND.  particles(n)%z < z_p )  THEN
 
              IF ( particles(n)%z < z0_av_global )  THEN
Index: palm/trunk/SOURCE/lpm_exchange_horiz.f90
===================================================================
--- palm/trunk/SOURCE/lpm_exchange_horiz.f90	(revision 1686)
+++ palm/trunk/SOURCE/lpm_exchange_horiz.f90	(revision 1691)
@@ -14,10 +14,10 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! ------------------
-! 
+! Formatting corrections.
 !
 ! Former revisions:
@@ -1208,5 +1208,5 @@
              ENDDO
 
-             IF ( n_start .GE. 0 )  THEN
+             IF ( n_start >= 0 )  THEN
                 pack_done = .FALSE.
                 DO  n = n_start, np_old_cell
Index: palm/trunk/SOURCE/lpm_init.f90
===================================================================
--- palm/trunk/SOURCE/lpm_init.f90	(revision 1686)
+++ palm/trunk/SOURCE/lpm_init.f90	(revision 1691)
@@ -14,10 +14,10 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Renamed prandtl_layer to constant_flux_layer.
 !
 ! Former revisions:
@@ -100,7 +100,7 @@
 
     USE control_parameters,                                                    &
-        ONLY:  cloud_droplets, current_timestep_number, dz,                    &
-               initializing_actions, message_string, netcdf_data_format,       &
-               ocean, prandtl_layer, simulated_time
+        ONLY:  cloud_droplets, constant_flux_layer, current_timestep_number,   &
+               dz, initializing_actions, message_string, netcdf_data_format,   &
+               ocean, simulated_time
 
     USE dvrp_variables,                                                        &
@@ -295,5 +295,5 @@
 !-- To obtain exact height levels of particles, linear interpolation is applied
 !-- (see lpm_advec.f90).
-    IF ( prandtl_layer )  THEN
+    IF ( constant_flux_layer )  THEN
        
        ALLOCATE ( log_z_z0(0:number_of_sublayers) ) 
Index: palm/trunk/SOURCE/microphysics.f90
===================================================================
--- palm/trunk/SOURCE/microphysics.f90	(revision 1686)
+++ palm/trunk/SOURCE/microphysics.f90	(revision 1691)
@@ -14,10 +14,11 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! ------------------
-! 
+! Added new routine calc_precipitation_amount. The routine now allows to account
+! for precipitation due to sedimenation of cloud (fog) droplets
 ! 
 ! Former revisions:
@@ -130,4 +131,10 @@
     END INTERFACE sedimentation_rain
 
+    INTERFACE calc_precipitation_amount
+       MODULE PROCEDURE calc_precipitation_amount
+       MODULE PROCEDURE calc_precipitation_amount_ij
+    END INTERFACE calc_precipitation_amount
+
+
  CONTAINS
 
@@ -208,4 +215,8 @@
 
        IF ( drizzle )  CALL sedimentation_cloud
+
+       IF ( precipitation )  THEN
+          CALL calc_precipitation_amount
+       ENDIF
 
     END SUBROUTINE microphysics_control
@@ -726,5 +737,5 @@
 
        USE cloud_parameters,                                                   &
-           ONLY:  eps_sb, hyrho, l_d_cp, nc_const, pt_d_t, sed_qc_const
+           ONLY:  eps_sb, hyrho, l_d_cp, nc_const, prr, pt_d_t, sed_qc_const
 
        USE constants,                                                          &
@@ -732,5 +743,6 @@
 
        USE control_parameters,                                                 &
-           ONLY:  dt_do2d_xy, dt_micro, intermediate_timestep_count
+           ONLY:  call_microphysics_at_all_substeps, dt_micro,                 &
+                  intermediate_timestep_count, precipitation
 
        USE cpulog,                                                             &
@@ -741,5 +753,9 @@
 
        USE kinds
-       
+
+       USE statistics,                                                         &
+           ONLY:  weight_substep
+    
+
        IMPLICIT NONE
 
@@ -777,4 +793,15 @@
                                         pt_d_t(k) * dt_micro
 
+!
+!--             Compute the precipitation rate due to cloud (fog) droplets
+                IF ( precipitation )  THEN
+                   IF ( call_microphysics_at_all_substeps )  THEN
+                      prr(k,j,i) = prr(k,j,i) +  sed_qc(k) / hyrho(k)          &
+                                   * weight_substep(intermediate_timestep_count)
+                   ELSE
+                      prr(k,j,i) = prr(k,j,i) + sed_qc(k) / hyrho(k)
+                   ENDIF
+                ENDIF
+
              ENDDO
           ENDDO
@@ -799,13 +826,9 @@
        USE cloud_parameters,                                                   &
            ONLY:  a_term, b_term, c_term, cof, dpirho_l, eps_sb, hyrho,        &
-                  limiter_sedimentation, l_d_cp, precipitation_amount, prr,    &
-                  pt_d_t, stp
+                  limiter_sedimentation, l_d_cp, prr,  pt_d_t, stp
 
        USE control_parameters,                                                 &
-           ONLY:  call_microphysics_at_all_substeps, dt_do2d_xy, dt_micro,     &
-                  dt_3d, intermediate_timestep_count,                          &
-                  intermediate_timestep_count_max,                             &
-                  precipitation_amount_interval, time_do2d_xy
-
+           ONLY:  call_microphysics_at_all_substeps, dt_micro,                 &
+                  intermediate_timestep_count
        USE cpulog,                                                             &
            ONLY:  cpu_log, log_point_s
@@ -1005,8 +1028,8 @@
 !--             Compute the rain rate
                 IF ( call_microphysics_at_all_substeps )  THEN
-                   prr(k,j,i) = prr(k,j,i) + sed_qr(k) / hyrho(k) *            &
-                                weight_substep(intermediate_timestep_count)
+                   prr(k,j,i) = prr(k,j,i) + sed_qr(k) / hyrho(k)             &
+                                * weight_substep(intermediate_timestep_count)
                 ELSE
-                   prr(k,j,i) = sed_qr(k) / hyrho(k)
+                   prr(k,j,i) = prr(k,j,i) + sed_qr(k) / hyrho(k)
                 ENDIF
 
@@ -1015,21 +1038,53 @@
        ENDDO
 
-!
-!--    Precipitation amount
-       IF ( intermediate_timestep_count == intermediate_timestep_count_max     &
-            .AND.  ( dt_do2d_xy - time_do2d_xy ) <                             &
-                   precipitation_amount_interval )  THEN
+       CALL cpu_log( log_point_s(60), 'sed_rain', 'stop' )
+
+    END SUBROUTINE sedimentation_rain
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Computation of the precipitation amount due to gravitational settling of
+!> rain and cloud (fog) droplets
+!------------------------------------------------------------------------------!
+    SUBROUTINE calc_precipitation_amount
+
+       USE cloud_parameters,                                                   &
+           ONLY:  hyrho, precipitation_amount, prr
+
+       USE control_parameters,                                                 &
+           ONLY:  call_microphysics_at_all_substeps, dt_do2d_xy, dt_3d,        &
+                  intermediate_timestep_count, intermediate_timestep_count_max,&
+                  precipitation_amount_interval, time_do2d_xy
+
+       USE indices,                                                            &
+           ONLY:  nxl, nxr, nys, nyn, nzb_s_inner
+
+       USE kinds
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  i                          !:
+       INTEGER(iwp) ::  j                          !:
+
+
+       IF ( ( dt_do2d_xy - time_do2d_xy ) < precipitation_amount_interval .AND.&
+            ( .NOT. call_microphysics_at_all_substeps .OR.                     &
+            intermediate_timestep_count == intermediate_timestep_count_max ) ) &
+       THEN
+
           DO  i = nxl, nxr
              DO  j = nys, nyn
+
                 precipitation_amount(j,i) = precipitation_amount(j,i) +        &
                                             prr(nzb_s_inner(j,i)+1,j,i) *      &
                                             hyrho(nzb_s_inner(j,i)+1) * dt_3d
+
              ENDDO
           ENDDO
        ENDIF
 
-       CALL cpu_log( log_point_s(60), 'sed_rain', 'stop' )
-
-    END SUBROUTINE sedimentation_rain
+    END SUBROUTINE calc_precipitation_amount
 
 
@@ -1121,4 +1176,8 @@
 
        IF ( drizzle )  CALL sedimentation_cloud( i,j )
+
+       IF ( precipitation )  THEN
+          CALL calc_precipitation_amount( i,j )
+       ENDIF
 
 !
@@ -1591,5 +1650,5 @@
 
        USE cloud_parameters,                                                   &
-           ONLY:  eps_sb, hyrho, l_d_cp, pt_d_t, sed_qc_const
+           ONLY:  eps_sb, hyrho, l_d_cp, prr, pt_d_t, sed_qc_const
 
        USE constants,                                                          &
@@ -1597,5 +1656,6 @@
 
        USE control_parameters,                                                 &
-           ONLY:  dt_do2d_xy, dt_micro, intermediate_timestep_count
+           ONLY:  call_microphysics_at_all_substeps, dt_do2d_xy, dt_micro,     &
+                  intermediate_timestep_count, precipitation
 
        USE indices,                                                            &
@@ -1604,4 +1664,7 @@
        USE kinds
        
+       USE statistics,                                                         &
+           ONLY:  weight_substep
+
        IMPLICIT NONE
 
@@ -1632,4 +1695,15 @@
           pt_1d(k) = pt_1d(k) - ( sed_qc(k+1) - sed_qc(k) ) * ddzu(k+1) /      &
                                 hyrho(k) * l_d_cp * pt_d_t(k) * dt_micro
+
+!
+!--       Compute the precipitation rate of cloud (fog) droplets
+          IF ( precipitation )  THEN
+             IF ( call_microphysics_at_all_substeps )  THEN
+                prr(k,j,i) = prr(k,j,i) + sed_qc(k) / hyrho(k) *               &
+                             weight_substep(intermediate_timestep_count)
+             ELSE
+                prr(k,j,i) = prr(k,j,i) +  sed_qc(k) / hyrho(k)
+             ENDIF
+          ENDIF
 
        ENDDO
@@ -1837,17 +1911,47 @@
 !--       Compute the rain rate
           IF ( call_microphysics_at_all_substeps )  THEN
-             prr(k,j,i) = prr(k,j,i) + sed_qr(k) / hyrho(k) *                  &
-                          weight_substep(intermediate_timestep_count)
+             prr(k,j,i) = prr(k,j,i) + sed_qr(k) / hyrho(k)                    &
+                          * weight_substep(intermediate_timestep_count)
           ELSE
-             prr(k,j,i) = sed_qr(k) / hyrho(k)
+             prr(k,j,i) = prr(k,j,i) + sed_qr(k) / hyrho(k)
           ENDIF
 
        ENDDO
 
-!
-!--    Precipitation amount
-       IF ( intermediate_timestep_count == intermediate_timestep_count_max     &
-            .AND.  ( dt_do2d_xy - time_do2d_xy ) <                             &
-                   precipitation_amount_interval )  THEN
+    END SUBROUTINE sedimentation_rain_ij
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> This subroutine computes the precipitation amount due to gravitational
+!> settling of rain and cloud (fog) droplets
+!------------------------------------------------------------------------------!
+    SUBROUTINE calc_precipitation_amount_ij( i, j )
+
+       USE cloud_parameters,                                                   &
+           ONLY:  hyrho, precipitation_amount, prr
+
+       USE control_parameters,                                                 &
+           ONLY:  call_microphysics_at_all_substeps, dt_do2d_xy, dt_3d,        &
+                  intermediate_timestep_count, intermediate_timestep_count_max,&
+                  precipitation_amount_interval,         &
+                  time_do2d_xy
+
+       USE indices,                                                            &
+           ONLY:  nzb_s_inner
+
+       USE kinds
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  i                          !:
+       INTEGER(iwp) ::  j                          !:
+
+
+       IF ( ( dt_do2d_xy - time_do2d_xy ) < precipitation_amount_interval .AND.&
+            ( .NOT. call_microphysics_at_all_substeps .OR.                     &
+            intermediate_timestep_count == intermediate_timestep_count_max ) ) &
+       THEN
 
           precipitation_amount(j,i) = precipitation_amount(j,i) +              &
@@ -1856,7 +1960,6 @@
        ENDIF
 
-    END SUBROUTINE sedimentation_rain_ij
-
-    
+    END SUBROUTINE calc_precipitation_amount_ij
+
 !------------------------------------------------------------------------------!
 ! Description:
